#pragma once

#include "CoreMinimal.h"
#include "Presenter.h"
#include "UObject/SoftObjectPtr.h"
#include "ChallengesMenuPresenter.generated.h"

class UUserWidget;
class UChallengesMenuChallengeSetSubPresenter;
class UMatchmakingMonitor;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIPRESENTERS_API UChallengesMenuPresenter : public UPresenter
{
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSoftClassPtr<UUserWidget> ChallengesMenuWidgetClass;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	UChallengesMenuChallengeSetSubPresenter* _challengeSetSubPresenter;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	UMatchmakingMonitor* _matchmakingMonitor;

private:
	UFUNCTION(BlueprintCallable)
	void RefreshChallengesList();

	UFUNCTION(BlueprintCallable)
	void OnSettingsButtonClicked();

	UFUNCTION(BlueprintCallable)
	void OnInfoButtonClicked();

	UFUNCTION(BlueprintCallable)
	void OnGoToRiftPassButtonClicked();

	UFUNCTION(BlueprintCallable)
	void OnGoToEventButtonClicked();

	UFUNCTION(BlueprintCallable)
	void OnChallengeSetSelected(const FString& challengeSetId, const FString& eventFrameLabel);

	UFUNCTION(BlueprintCallable)
	void OnBackButtonClicked();

public:
	UChallengesMenuPresenter();
};

FORCEINLINE uint32 GetTypeHash(const UChallengesMenuPresenter) { return 0; }
